from machine import Pin, PWM
from machine import ADC, I2C
import ssd1306
import time, utime

pwm_SG=PWM(Pin(21))
pwm_SG.freq(500000)
pwm_SG.duty_u16(65535//2)

pwm_ZEROADJ=PWM(Pin(22))
pwm_ZEROADJ.freq(500000)
pwm_ZEROADJ.duty_u16(0)

button = Pin(28, Pin.IN, Pin.PULL_UP)

i2c = machine.I2C(0, sda=Pin(16), scl=Pin(17))
oled = ssd1306.SSD1306_I2C(128, 32, i2c)

Vcoeff = 3.3 / 65535
Lcoeff = 8.78
wrap = 250
Pin(26, Pin.IN)
a = ADC(0)

def wave(i):
    return int((65535/wrap)*i)

def callback(pin):
    global sw_on
    sw_on = pin

def zeroadj():
    for i in range(wrap):
        pwm_ZEROADJ.duty_u16(wave(i))
        utime.sleep_ms(10)
        v = a.read_u16() * Vcoeff
        if ( v < 0.05 ):
            return
    return

button.irq(trigger = Pin.IRQ_FALLING, handler = callback)
global sw_on
sw_on = None

while True:
    if sw_on:
        zeroadj()
        sw_on = None
    L = a.read_u16() * Vcoeff * Lcoeff
    L = round(L,1)
    oled.fill(0)
    oled.text(str(L)+' cm',20,5)
    oled.rect(0,0,100,18,1)
    oled.show()
    time.sleep(1)
